#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#define GLOBAL		1
#define LOCAL		2
#define MAYBE_LOCAL	3
#define IN_STRUCT	4
#define IN_SQUARE	5

#define HEAPSIZE (4 * 1024)

int command(char *,...);
int Fail(char *,...);
char *FindSymbol(int table, char *sym);
int NewTable(void);
int FreeTable(int);
int PushSymbol(int , char *, ...);
void ReplaceSymbol(int,int,char *);
int PopSymbols(int, int);
void DumpTable(int);
void DumpTables(void);
void GetReturnVal(int,char *, char *);
int GetSymData(int, char *, int, char *);
int CopySymbols(int,int,int);
void PushInt(int);
int PopInt(void);
void PushString(char *);
void PopString(char *);
int NumSymbols(int);
void DeclareVariable(int,char *, char *,int);
int GetVariable(int,int,char *, char *, int *);
void SetVariableLocation(int,int,int);
int GetVariableLocation(int,int);
int CheckParameters(char *, int);
int GetField(char *,int, char *);
int GetTypeSize(char *);
void DeclareReal(char *);
void DeclareInt(char *);
void WriteGlobals(void);
void WriteTypes(void);

/*
** Instruct.c
*/
void OutputInstruction(char *,...);
void CheckpointInstructionBuffer(void);
void RollbackInstructionBuffer(void);
char *Expression2(char *, char *);
char *Expression3(char *, char *, char *);

extern int t_table;	/* current type table */
extern int gt_table;	/* global type table */
extern int v_table;	/* current variable table */
extern int gv_table;	/* global variable table */
extern int p_table;	/* current prototype table */
extern int gp_table;	/* global prototype table */

extern char funcname[],functype[],dimdef[];
extern int LineNum;
extern char Heap[];
extern int StackPointer,scope,HeapOffset;;
